<%-- 
    Document   : index
    Created on : 12 août 2015, 11:45:08
    Author     : A. YEZZA
--%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %> 
<%@page contentType="text/html" pageEncoding="UTF-8" %>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>CRUD 100% AJAX and JSON</title>
        
         <!-- Bootstrap CSS and JS-->
        <link href="bootstrap/css/bootstrap.min.css" rel="stylesheet">
         
        
    </head>
    <body>
      
    
    
   
    
    <div class="container" style="width: 80%;">
        <div class="panel panel-primary">
            <div class="panel-heading panel-title">The CRUD by using 100% AJAX and JSON • ©2015, Abdel YEZZA, Ph.D</div>
            <!-- This part is dedicated to navigate the resultset --> 
            <div class="col-xs-12 well well-sm">
                <!-- Get all users section -->
                <button class="btn btn-primary" value="getUser" onclick="GetUserInfosBtn();">
                    <span class="glyphicon glyphicon-user"></span> Get Users
                </button> 
                <button class="btn btn-primary" id="first"  value="firstUser" onclick="getNextOrPrevious('first');" title="First" disabled="true">
                    <span class="glyphicon glyphicon-step-backward"></span>
                </button>
                <button class="btn btn-primary" id="previous" value="nextUser" onclick="getNextOrPrevious('previous');"  disabled="true">Previous</button>
                <span class="badge" name="counter" id="counter"></span>
                <button class="btn btn-primary" id="next" value="previousUser" onclick="getNextOrPrevious('next');" disabled="true">Next</button>
                 <button class="btn btn-primary" id="last" value="lastUser" onclick="getNextOrPrevious('last');" title="Last" disabled="true">
                    <span class="glyphicon glyphicon-step-forward"></span>
                </button>

                <!-- Search section -->
                <span class="caption pull-right">
                    <button class="btn btn-danger" name="crud" id="search" value="search" title="Rechercher" onclick="GetSearchResult();">
                        <span class="glyphicon glyphicon-search"></span> By:
                    </button>
                    <select class="input-sm" id="searchBy" onchange="GetSearchBy()">
                        <option name="searchOption" value="What">--Select field search--</option>
                        <option name="searchOption" value="id">ID</option>
                        <option name="searchOption" value="nom">Last Name</option>
                        <option name="searchOption" value="prenom">First Name</option>
                        <option name="searchOption" value="email">EMAIL</option>
                    </select>
                    <input class="input-sm" type="text" id="searchWhat" name="searchWhat" 
                           placeholder="Expression à rechercher" 
                           onchange="GetSearchWhat()"/>
                    <input type="text" name="searchWhatVal" id="searchWhatVal" hidden="true"/>
                    <input type="text" name="searchByVal" id="searchByVal" hidden="true"/>
                </span>

            </div>



            
            <!-- This is the form containing the CRUD -->    
            <div class="panel-body">
                <form method="post" action="UserCRUD" class="form-group" accept-charset="UTF-8">

                    <div class="row">
                        <p class="alert alert-info" style="color: <c:out value='${message.msgColor}'></c:out>" 
                           name="message" id="message"> <c:out value='${message.message}'></c:out>
                        </p>
                    </div>
                    <div class="row">
                        <div class="col-xs-4 control-group">
                            <label class="control-label" for="id">ID :</label>
                        </div>
                        <div class="col-xs-8 controls">
                            <input type="text" class="form-control input-sm" 
                                   name="id" id="id" readonly="true" maxlength="10"
                                   value="<c:out value="${User.id}"></c:out>"  />

                        </div>

                        <div class="col-xs-4 control-group">
                            <label class="control-label" for="nom">Last Name :</label>
                        </div>
                        <div class="col-xs-8 controls">
                            <input type="text"  class="form-control input-sm" 
                                   name="nom" id="nom" maxlength="32" min="3"
                                value="<c:out value="${User.nom}"></c:out>" />

                        </div>

                        <div class="col-xs-4 control-group">
                            <label class="control-label" for="prenom">First Name :</label>
                        </div>
                        <div class="col-xs-8 controls">
                            <input type="text" class="form-control input-sm" 
                                   name="prenom" id="prenom" maxlength="32" min="3"
                                   value="<c:out value="${User.prenom}"></c:out>"  />
                        </div>

                        <div class="col-xs-4 control-group">
                            <label class="control-label" for="email">EMAIL :</label>
                        </div>
                        <div class="col-xs-8 controls">
                            <input type="email" class="form-control input-sm" 
                                   name="email" id="email" maxlength="32"
                                   value="<c:out value="${User.email}"></c:out>"  />
                        </div>

                        <div class="col-xs-4 control-group">
                            <label class="control-label" for="pwd">Password :</label>
                        </div>
                        <div class="col-xs-8 controls">
                            <input type="password" class="form-control input-sm" 
                                   name="password" id="pwd" maxlength="32" pattern=".{4,32}"
                                   value="<c:out value="${User.pwd}"></c:out>"  />
                        </div>

                        <div class="col-xs-4 control-group">
                            <label class="control-label" for="dateNaissance">Date of Birth :</label>
                        </div>
                        <div class="col-xs-8 controls">
                            <input type="date" class="form-control input-sm" 
                                   name="dateNaissance" id="dateNaissance"
                                   value="<c:out value="${User.dateNaissance}"></c:out>"  />
                        </div>

                    </div>

                    <div class="panel panel-footer">
                        <button type="reset" class="btn btn-danger" value="reset" onclick="ResetFields();">RESET fields</button>

                        <button type="submit" class="btn btn-primary" 
                                name="crud" value="addUser">
                            <span class="glyphicon glyphicon-plus"></span> Add User
                        </button>
                        <button type="submit" class="btn btn-primary" 
                                name="crud" value="delUser">
                            <span class="glyphicon glyphicon-minus"></span> Remove User
                        </button>
                        <button type="submit" class="btn btn-primary" 
                                name="crud" value="updateUser">
                            <span class="glyphicon glyphicon-upload"></span> Update User Data
                        </button>



                    </div>
                </form>
            </div>

        </div>  
    </div>    
        
   <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
   <script type="text/javascript" src="bootstrap/js/bootstrap.min.js"></script>      
   <script src="scripts/getResult.js"></script>
        
    </body>
</html>
