/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.yezza.dao;

import com.google.gson.Gson;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.concurrent.atomic.AtomicReference;
import java.util.logging.Level;
import java.util.logging.Logger;
import com.yezza.business.User;
import com.yezza.controllers.UserCRUD;
import com.yezza.utils.SqlUtil;

/**
 *
 * @author ayezza
 */
public class UserDAO implements IUser{

   
    /**
     * get JSON string represtation of all users
     * @return 
     */
    @Override
    public String getAllUsers() {
        Gson gson=new Gson();
        
        PreparedStatement req = null;
        ResultSet res = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("SELECT * FROM users");
                res=req.executeQuery();
                return ConstructUserJsonString (res);
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    res.close();
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return "";
    }

    
    public static java.util.Date convertFromSQLDateToJAVADate(
            java.sql.Date sqlDate) {
        java.util.Date javaDate = null;
        if (sqlDate != null) {
            javaDate = new Date(sqlDate.getTime());
        }
        return sqlDate;
    }
    
    /**
     * Add user pUser
     * @param pUser
     * @param errorMsg
     * @return 
     */
    @Override
    public boolean addUser(User pUser, AtomicReference<String> errorMsg) {
        if ( ("".equals(getUserByEmail(pUser.getEmail())) ) == false ) {
            errorMsg.set("Cet utilisateur existe déjà. Choisir une autre adresse MAIL.");
            return false;
        }
        
        PreparedStatement req = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("INSERT INTO users(nom,prenom,email,password,date_naissance) VALUES(?,?,?,?,?)");
                req.setString(1, pUser.getNom());
                req.setString(2, pUser.getPrenom());
                req.setString(3, pUser.getEmail());
                req.setString(4, pUser.getPwd());
                //Convert util.Date to sql.Date
                java.util.Date utilDate = pUser.getDateNaissance();
                java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
                req.setDate(5,  sqlDate);
                return (1==req.executeUpdate());
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                errorMsg.set(ex.getMessage());
            } finally {
                try {
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                    errorMsg.set(ex.getMessage());
                }
            }
        }
        return false;
    }

    @Override
    public boolean delUser(User pUser, AtomicReference<String> errorMsg) {
     
        PreparedStatement req = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("DELETE FROM users WHERE id_user=?");
                req.setInt(1, pUser.getId());
                
                return (1==req.executeUpdate());
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                errorMsg.set(ex.getMessage());
            } finally {
                try {
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                    errorMsg.set(ex.getMessage());
                }
            }
        }
        return false;
    }

    @Override
    public boolean updateUser(User pInUser, AtomicReference<String> errorMsg) {
        
        PreparedStatement req = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("UPDATE users SET nom=?, prenom=?, email=?, password=?, date_naissance=? WHERE id_user=?");
                
                req.setString(1, pInUser.getNom());
                req.setString(2, pInUser.getPrenom());
                req.setString(3, pInUser.getEmail());
                req.setString(4, pInUser.getPwd());
                java.util.Date utilDate = pInUser.getDateNaissance();
                java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
                req.setDate(5, sqlDate);
                req.setInt(6, pInUser.getId());
                
                return (1==req.executeUpdate());
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                errorMsg.set(ex.getMessage());
            } finally {
                try {
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                    errorMsg.set(ex.getMessage());
                }
            }
        }
        return false;
    }

    
    @Override
    public ResultSet getAllUsersResultSet() {
        PreparedStatement req = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("SELECT * FROM users");
                return req.executeQuery();
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return null;
    }

    @Override
    public String getUserById(int pId) {
        PreparedStatement req = null;
        ResultSet res = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("SELECT id_user,nom,prenom,password,email,date_naissance FROM users WHERE id_user=?");
                req.setInt(1, pId);
                res=req.executeQuery();
                return ConstructUserJsonString (res);
                
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    res.close();
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return ""; 
    }

    private String ConstructUserJsonString(ResultSet res){
        Gson gson=new Gson(); 
        String str="";
        try {
            while (res.next()) {
                str+=(res.isFirst()?"[":"") + gson.toJson(new User(res.getInt("id_user"),
                        res.getString("nom"),
                        res.getString("prenom"),
                        res.getString("email"),
                        res.getString("password"),
                        res.getDate("date_naissance") ) ) + (res.isLast()?"]":",");
            }
        } catch (SQLException ex) {
            Logger.getLogger(UserDAO.class.getName()).log(Level.SEVERE, null, ex);
        }
        return str;
    }
    
    @Override
    public String getUsersByName(String pName) {
        //Gson gson=new Gson();
        
        PreparedStatement req = null;
        ResultSet res = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("SELECT id_user,nom,prenom,password,email,date_naissance FROM users WHERE nom LIKE ?");
                req.setString(1, pName);
                res=req.executeQuery();
                return ConstructUserJsonString (res);
                
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    res.close();
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return ""; 
    }

    @Override
    public String getUsersByPrenom(String pPrenom) {
        PreparedStatement req = null;
        ResultSet res = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("SELECT id_user,nom,prenom,password,email,date_naissance FROM users WHERE prenom LIKE ?");
                req.setString(1, pPrenom);
                res=req.executeQuery();
                return ConstructUserJsonString (res);
                
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    res.close();
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return ""; 
    }

    @Override
    public String getUserByEmail(String pEmail) {
        PreparedStatement req = null;
        ResultSet res = null;
        java.sql.Connection cn=SqlUtil.getConnection();
        
        if (null!=cn) {
            try {
                req=cn.prepareStatement("SELECT id_user,nom,prenom,password,email,date_naissance FROM users WHERE email=?");
                req.setString(1, pEmail);
                res=req.executeQuery();
                return ConstructUserJsonString (res);
                
            } catch (SQLException ex) {
                Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    res.close();
                    req.close();
                    cn.close();
                } catch (SQLException ex) {
                    Logger.getLogger(UserCRUD.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return ""; 
    }

    
}
